function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, Index, JoinColumn, Column, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
import { DriveFile } from "./drive-file.js";
export let Channel = class Channel {
    id;
    createdAt;
    lastNotedAt;
    userId;
    user;
    name;
    description;
    bannerId;
    banner;
    notesCount;
    usersCount;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], Channel.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the Channel."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], Channel.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Channel.prototype, "lastNotedAt", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        nullable: true,
        comment: "The owner ID."
    }),
    _ts_metadata("design:type", Object)
], Channel.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "SET NULL"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Channel.prototype, "user", void 0);
_ts_decorate([
    Column("varchar", {
        length: 128,
        comment: "The name of the Channel."
    }),
    _ts_metadata("design:type", String)
], Channel.prototype, "name", void 0);
_ts_decorate([
    Column("varchar", {
        length: 2048,
        nullable: true,
        comment: "The description of the Channel."
    }),
    _ts_metadata("design:type", Object)
], Channel.prototype, "description", void 0);
_ts_decorate([
    Column({
        ...id(),
        nullable: true,
        comment: "The ID of banner Channel."
    }),
    _ts_metadata("design:type", Object)
], Channel.prototype, "bannerId", void 0);
_ts_decorate([
    ManyToOne((type)=>DriveFile, {
        onDelete: "SET NULL"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Channel.prototype, "banner", void 0);
_ts_decorate([
    Index(),
    Column("integer", {
        default: 0,
        comment: "The count of notes."
    }),
    _ts_metadata("design:type", Number)
], Channel.prototype, "notesCount", void 0);
_ts_decorate([
    Index(),
    Column("integer", {
        default: 0,
        comment: "The count of users."
    }),
    _ts_metadata("design:type", Number)
], Channel.prototype, "usersCount", void 0);
Channel = _ts_decorate([
    Entity()
], Channel);
